#!/usr/bin/perl -w
# dansguardian-lib.pl

do '../web-lib.pl';
&init_config();

# Get the DG version
if (open(VERSION, "$module_config_directory/version")) {
  chop($dg_version = <VERSION>);
  close(VERSION);
}

# Read in the dansguardian.conf file
$cfref = read_file_lines($conffilepath);
$modulever = "0.3.6";

sub readconfigoption {
    my $option = $_[0];
    my $value;
    my $name;
    my $line;
    foreach $line (@$cfref) {
        ($name, $value) = split(/=/, $line);
        $name =~ s/ //g;
        if ($name eq $option) {
            $value =~ s/ //g;
            $value =~ s/^'//g;
            $value =~ s/'.*$//g;       
            return $value;
        }
    }
}

# form_line(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub form_line {
    my $option = $_[0];
    my $size = $_[1];
    my $maxlen = $_[2];
    my $helpfile = $_[3];
    my $editable = $_[4];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td><input name=$option size=$size maxlength=$maxlen value=$value>";
    if ($editable ne "") {
        print " <A HREF=\"./edit.cgi?file=$value\">$editable</a>";
    }
    print "</td></tr>"
}

# form_option(<configfileoptionname>)
sub form_option {
    my $option = $_[0];
    my $helpfile = $_[1];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td>", "<td><input type=checkbox name=$option value=\"on\"";
    if ($value eq 'on') {
        print 'CHECKED';
    }
    print "></td></tr>\n";
}
# form_radio(<configfileoptionname>, <option 1>, <option 2>, ...)
sub form_radio {
    my @options = @_;
    my $option = $options[0];
    my $optionconf = "conf_$option";
    my $optionradio = $optionconf . "_radio_";
    my $label = $text{$optionconf};
    my $helpfile = $options[0];
    my $value = readconfigoption($option);
    my $radio = "blah";
    my $radioname;
    my $i = 1;
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td><td>";
    while($radio ne "") {
        $radio = $options[$i];
        if (length($radio) > 0) {
            print "<INPUT TYPE=RADIO NAME=\"$option\" VALUE=\"$radio\"";
            if ($radio eq $value) {
                print " CHECKED";
            }
            $radioname = $optionradio . "$i";
            print "> $radio = $text{$radioname}<BR>";
        }
        $i++;
    }
    print "</td>";
}

sub form_file {
    my $option = $_[0];
    my $fileref = read_file_lines($option);
    my $line;
    print "<INPUT TYPE=HIDDEN NAME=\"filename\" VALUE=\"$option\">";
    print "<TEXTAREA NAME=\"filecontents\" ROWS=30 COLS=80>";
    foreach $line (@$fileref) {
        print "$line\n";
    }
    print "</TEXTAREA>";
}

# restart_button()
# Returns HTML for a link to put in the top-right corner
# I stole this from the apache module
sub restart_button {
    my $pidfile = "$pidfilepath";
    if (open(PID, $pidfile) && <PID> =~ /(\d+)/ && kill(0, $1)) {
        close(PID);
        $rv = "<a href=\"restart.cgi\">$text{'header_restartdg'}</a><br>\n";
        $rv .= "<a href=\"stop.cgi\">$text{'header_stopdg'}</a>\n";
    }
    else {
        $rv = "<a href=\"start.cgi\">$text{'header_startdg'}</a><br>\n";
    }
    return $rv;
}
