#!/usr/bin/perl
# index.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();
$pidfilepath = "$config{'pid_file'}";

# Check the version number
$ver = `$config{'binary_file'} -v 2>&1`;
if ($ver =~ /(2\.4\.\d)/) {
    # Save version number
    open(VERSION, ">$module_config_directory/version");
    print VERSION $1,"\n";
    close(VERSION);
    $dg_version = $1;
    }
else {
    &header($text{'index_header'}, "", undef, 1, 1);
    print "<hr>\n";
    print "<p>";
    print $text{'index_notsupported'};
    print "<p>";
    print &text('index_dgver');
    print "$config{'binary_file'} -v","\n";
    print "<pre>$ver</pre>\n";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
    exit;
}


&header($text{'index_title'}, "", "intro", 1, 1, 0, &restart_button()."<br>".
  &help_search_link("dansguardian", "man"), undef, undef, &text('index_version')." ".$dg_version);
  
print "$text{'index_modulever'} $modulever\n";

# Check if DansGuardian is installed
if (!(-x $config{'binary_file'})) {
    print "<p>";
    print &text('error_binnotfound', $config{'binary_file'}, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_binaryloc'} $config{'binary_file'}.";
    print "<hr>\n";
}

print "<hr>\n";

# Set the arrays for the links, titles, and icons of each option
@olinks = ( "start.cgi", "stop.cgi", "restart.cgi", "forcedkill.cgi", "status.cgi", "viewconf.cgi", "viewlog.cgi" );

@otitles = ( "$text{'index_startdg'}", "$text{'index_stopdg'}", "$text{'index_restartdg'}", "$text{'index_forcedkilldg'}", "$text{'index_statusdg'}", "$text{'index_viewconf'}", "$text{'view_dglog'}" );

@oicons = ( "images/start.gif", "images/stop.gif", "images/restart.gif", "images/forcedkill.gif", "images/status.gif", "images/config.gif", "images/viewlog.gif" );

# Use the webmin function to print the table
&icons_table(\@olinks, \@otitles, \@oicons, 3);

print "<hr>\n";

# Check if DansGuardian conf file is there
$conffilepath = "$config{'conf_path'}/dansguardian.conf";
if (!(-f $conffilepath)) {
    print "<p>";
    print &text('error_confnotfound', $conffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $conffilepath.";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
    exit;
}
print "<p align=left>$text{'index_search_title'}";
print "<p align=left><form action=search.cgi>\n";
print "<input name=search size=20 maxlength=20 value=\"$text{'index_search'}\">";
print "<P><input type=submit></form>\n";
print '<P>';

print "<hr>\n";
&footer("/", $text{'index'});
exit;
